<template>
  <h1>UserTable</h1>
  <div class="container">
    <table class="table">
      <thead>
        <tr>
          <th v-for="item in listaItems" :key="item.id">{{ item }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="user in users" :key="user.id">
          <th>{{ user.id }}</th>
          <td>{{ user.name }}</td>
          <td>{{ user.lastName }}</td>
          <td>{{ user.address }}</td>
          <td>
            <div class="d-flex">
              <button
                type="button"
                data-bs-toggle="modal"
                data-bs-target="#editarUsuarioModal"
                class="btn btn-outline-primary me-4"
                @click="sendUserData(user)"
              >
                Editar
              </button>
              <button @click="deleteUser(user.id)" class="btn btn-outline-danger me-4">Eliminar</button>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>

  <!-- Modal -->
  <div
    class="modal fade"
    id="editarUsuarioModal"
    tabindex="-1"
    aria-labelledby="editarUsuarioModalLabel"
    aria-hidden="true"
  >
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h4>
            Editar Usuario 
          </h4>
        </div>
        <div class="modal-body">
          <div class="d-flex flex-column">
            <label class="form-label">Nombre</label>
            <input class="mb-4 form-control" type="text" v-model="updateName" />
            <label class="form-label">Apellido</label>
            <input type="text" class="form-control" v-model="updateLastName" />
            <label class="mt-4 form-label">Dirección</label>
            <input type="text" class="form-control" v-model="updateAddress" />
          </div>
        </div>
        <div class="modal-footer">
          <button
            type="button"
            class="btn btn-secondary"
            data-bs-dismiss="modal"
          >
            Cerrar
          </button>
          <button
            @click="
              updateUser(
                selectedUser.id,
                updateName,
                updateLastName,
                updateAddress
              )
            "
            type="button"
            class="btn btn-primary"
          >
            Editar usuario
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      listaItems: ["Id", "Nombre", "Apellido", "Dirección", "Opciones"],
      users: [],
      selectedUser: "",
      updateName: "",
      updateLastName: "",
      updateAddress: "",
    };
  },
  methods: {
    async updateUser(userId, userName, userLastName, userAddress) {
      await axios
        .put(`http://localhost:9090/users/${userId}`, {
          name: userName,
          lastName: userLastName,
          address: userAddress,
        })
        .then((resp) => {
          console.log(resp.data);
          location.reload();
        });
    },
    async deleteUser(userId) {
      await axios
        .delete(`http://localhost:9090/users/${userId}`)
        .then((resp) => {
          console.log(resp.data);
          location.reload();
        });
    },
    sendUserData(user) {
      this.selectedUser = user;
    },
  },
  async mounted() {
    await axios.get("http://localhost:9090/users").then((respuesta) => {
      console.log(respuesta.data);
      this.users = respuesta.data;
    });
  },
};
</script>

<style></style>
